unit uperszahl;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, Grids;

type

  { Tfperszahl }

  Tfperszahl = class(TForm)
    BitBtn1: TBitBtn;
    b_persliste: TButton;
    b_statistik: TButton;
    b_speichern: TButton;
    e_durchschnitt: TEdit;
    e_perszahl: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lb_persliste: TListBox;
    l_pkwzahl: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    t_statistik: TStringGrid;
    procedure b_statistikClick(Sender: TObject);
    procedure b_perslisteClick(Sender: TObject);
    procedure b_speichernClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fperszahl: Tfperszahl;
  perszahl : ARRAY[1..100] OF BYTE;
  pkwzahl : BYTE;

implementation

{$R *.lfm}

{ Tfperszahl }

procedure Tfperszahl.FormCreate(Sender: TObject);
VAR i,b : BYTE;
begin
  //Init
  pkwzahl := 1;
  FOR i:=1 TO 100 DO perszahl[i] := 0;

  //Tabellenstyle
  t_statistik.cells[0,0]:='Personenzahl';
  t_statistik.cells[0,1]:='PKW-Zahl';
  FOR b:= 1 TO 8 DO BEGIN
    t_statistik.ColWidths[b]:=24;
    t_statistik.cells[b,0]:=INTTOSTR(b);
  END;

end;

procedure Tfperszahl.b_speichernClick(Sender: TObject);
begin
  //Eingabe
  perszahl[pkwzahl] := STRTOINT(e_perszahl.text); //Personenzahl pro PKW
  pkwzahl := pkwzahl +1;                          //PKW-Zahl um 1 erhöhen
  l_pkwzahl.caption := INTTOSTR(pkwzahl);         //Label PKW-Zahl erhält aktuelle PKW-Zahl
  e_perszahl.Clear;                               //Edit-Feld für die nächste Eingabe säubern
end;

procedure Tfperszahl.b_perslisteClick(Sender: TObject);
VAR i : BYTE;
begin
  lb_persliste.Clear;
  FOR i := 1 TO pkwzahl-1 DO lb_persliste.items.add(INTTOSTR(perszahl[i]));
end;

procedure Tfperszahl.b_statistikClick(Sender: TObject);
VAR perssumme,e,z,d,v,f,s,si,a,i,j : WORD;
    ds : SINGLE;
begin
 //Init
 e:=0;z:=0;d:=0;v:=0;f:=0;s:=0;si:=0;a:=0;perssumme:=0;

 //Gesamtzahl Personen
 FOR i := 1 TO pkwzahl-1 DO perssumme:=perssumme + perszahl[i];

 //Statistik
 FOR i := 1 TO pkwzahl-1 DO
  CASE perszahl[i] OF
   1 : e:=e+1;
   2 : z:=z+1;
   3 : d:=d+1;
   4 : v:=v+1;
   5 : f:=f+1;
   6 : s:=s+1;
   7 : si:=si+1;
   8 : a:=a+1;
  END;

 //Tabelle füllen
 t_statistik.cells[1,1]:=INTTOSTR(e);
 t_statistik.cells[2,1]:=INTTOSTR(z);
 t_statistik.cells[3,1]:=INTTOSTR(d);
 t_statistik.cells[4,1]:=INTTOSTR(v);
 t_statistik.cells[5,1]:=INTTOSTR(f);
 t_statistik.cells[6,1]:=INTTOSTR(s);
 t_statistik.cells[7,1]:=INTTOSTR(si);
 t_statistik.cells[8,1]:=INTTOSTR(a);

 //Berechnung Durchschnitt
 ds:=perssumme/(pkwzahl-1);
 e_durchschnitt.text:=FLOATTOSTRF(ds,ffnumber,8,2);

end;

end.

